'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const save = exports.save = db => (() => {
  var _ref = _asyncToGenerator(function* (user) {
    const { id } = user;
    try {
      const userCol = db.collection('users');

      const { value } = yield userCol.findOneAndUpdate({ id }, { $set: { user } }, { returnOriginal: false, upsert: true });

      return value;
    } catch (e) {
      throw e;
    }
  });

  return function (_x) {
    return _ref.apply(this, arguments);
  };
})();
const get = exports.get = db => (() => {
  var _ref2 = _asyncToGenerator(function* (id) {
    try {
      const userCol = db.collection('users');

      const user = yield userCol.findOne({ id });
      if (!user) {
        throw new Error('User Not Found');
      }
      return user;
    } catch (e) {
      throw e;
    }
  });

  return function (_x2) {
    return _ref2.apply(this, arguments);
  };
})();

const list = exports.list = db => _asyncToGenerator(function* () {
  try {
    const userCol = db.collection('users');

    const users = yield userCol.find().toArray();

    return users;
  } catch (e) {
    throw e;
  }
});